local T = Deadened_T()
Deadened_T = nil

Deadened = AceLibrary("AceAddon-2.0"):new("AceHook-2.1", "AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
Deadened:RegisterDB("DeadenedDB", "DeadenedDBPC", "profile")
Deadened:RegisterDefaults('profile', {
	handlers = {},
	tankmode = false
})

local handlers = {}

function Deadened:OnInitialize()
	self:CheckLocale()
end

function Deadened:OnEnable()
	self:RegisterEvent("Ace2_AddonEnabled")
	self:RegisterEvent("Ace2_AddonDisabled")
	
	local options = {
		type = "group",
		args = {
			tankmode = {
				type = "toggle",
				name = "Tank mode",
				desc = "Suppress Spirit Shock instead of Deaden",
				get = function()
					return Deadened.db.profile.tankmode
				end,
				set = function(v)
					Deadened.db.profile.tankmode = v
				end
			}
		}
	}
	
	for k, v in pairs(handlers) do
		if self.db.profile.handlers[k] ~= false then
			v:Hook(true)
		end
		options.args[k] = {
			type = "toggle", 
			name = k, 
			desc = "Toggle " .. k, 
			get = function()
				return Deadened.db.profile.handlers[k] ~= false or false
			end,
			set = function(v)
				Deadened.db.profile.handlers[k] = v
				if v then
					handlers[k]:Hook(true)
				else
					handlers[k]:Unhook(true)
				end
			end
		}
	end	
	Deadened:RegisterChatCommand("/deaden", options)	
end

function Deadened:OnDisable()
	self:UnhookAll()
end

function Deadened:CheckLocale()
	if T[GetLocale()] == nil then
		error("No localization for Deadened in " .. GetLocale())
	end
end

function Deadened:IsDeaden(v)
	self:CheckLocale()
	if self.db.profile.tankmode then
		return T[GetLocale()]["Spirit Shock"] == v
	else
		return T[GetLocale()]["Deaden"] == v
	end
end

function Deadened:Ace2_AddonEnabled(module)
	for k, v in pairs(handlers) do
		v:Hook(module)
	end
end

function Deadened:Ace2_AddonDisabled(module, first)
	for k, v in pairs(handlers) do
		v:Unhook(module)
	end
end

function Deadened:UNIT_SPELLCAST_START(orig_object, unit)
	if unit == "target" then
		local spell, rank, displayName, icon, startTime, endTime = UnitCastingInfo(unit)
		if not Deadened:IsDeaden(displayName) then
			for k,v in pairs(self.hooks[orig_object]) do
				v(orig_object, unit)
			end
		end
	end	
end

function Deadened:AddHandler(name, handler)	
	handlers[name] = handler
end
